// $Date:: 2014-07-27 02:52:58 +0900#$
// $Rev: 11 $


#include "convert8to16_sse4.h"
#include "convert8to16_nosse.h"
#include "convert8to16_noopt.h"
#include <intrin.h>

/**************************************************************************************************/
/* Global                                                                                         */
/**************************************************************************************************/
static uint32_t AutoSSEOptimization()
{
	int32_t CPUInfo[4];
	__cpuid(CPUInfo, 1);

	// SSE2 p\H
	if (CPUInfo[3] & 0x04000000)
	{
		// SSE3/4.1 p\H
		if ((CPUInfo[2] & 0x00080001) == 0x00080001)
			return 3;

		return 2;
	}
	return 1;
}
//==============================================================================
// Create_Convert8to16
//==============================================================================
AVSValue __cdecl Create_Convert8to16(AVSValue args, void* user_data, IScriptEnvironment* env)
{
	PClip & c = args[0].AsClip();
	if (!c->GetVideoInfo().IsYV12())
		env->ThrowError("equalize: Requires YV12 input");

	// œKIvV̎擾
	const uint32_t sseopt = args[1].AsInt(0);

	// m[}CY
	const uint32_t span = args[2].AsInt(3);

	// Gba臒liPxj
	const uint32_t ythr = args[3].AsInt(1);

	// Gba臒liʓxj
	const uint32_t cthr = args[4].AsInt(1);

	// [h
	const uint32_t mode = args[5].AsInt(0);

	// fobO\
	const bool debug = args[6].AsBool(false);

	// œKIvVȂ cpuid Őݒ
	switch (sseopt ? sseopt : ::AutoSSEOptimization())
	{
	case 1:
		return new convert8to16_noopt::Convert8to16(c, env, span, ythr, cthr, mode, debug);
	case 2:
		//return new convert8to16_sse2::Convert8to16(c, env, span, ythr, cthr, mode, debug);
		return new convert8to16_nosse::Convert8to16(c, env, span, ythr, cthr, mode, debug);
	case 3:
		return new convert8to16_sse4::Convert8to16(c, env, span, ythr, cthr, mode, debug);
	default:
		env->ThrowError("equalize: \"sseopt\" should be 0 to 3.(default:0)");
	}

	return NULL;

    env->ThrowError("Convert8to16: Requires YUY2 input");
    return NULL ;
}

//==============================================================================
// AvisynthPluginInit2
//==============================================================================
extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env)
{
    env->AddFunction("Convert8to16", "c[sseopt]i[span]i[ythr]i[cthr]i[mode]i[debug]b", Create_Convert8to16, 0);
    return "Convert8to16 ver 0.1";
}
